import ConfigManager from "./ConfigManager";

export default class ResourcesLoadMgr {
    static getInstance(): ResourcesLoadMgr {
        if (ResourcesLoadMgr.instance == null) {
            ResourcesLoadMgr.instance = new ResourcesLoadMgr();
        }
        return ResourcesLoadMgr.instance;
    }
    private static instance: ResourcesLoadMgr = null;
    private prefabList = {};
    getPrefab(prefabName: string, callback): void {
        if (this.prefabList[prefabName] != null) {
            callback(null, this.prefabList[prefabName]);
            return;
        }
        let target = this;
        let resPath: string = prefabName;
        if (!/.*\/.*/i.test(prefabName)) { // 文件名中包含 '/'自动识别为绝对路径
            resPath = ConfigManager.GetPrefabPath(prefabName);
        }
        if (resPath == "") {
            resPath = prefabName;
        }

        cc.loader.loadRes(resPath, cc.Prefab, function (err, prefab) {
            target.prefabList[prefabName] = prefab;
            if (callback) {
                callback(err, prefab);
            }
        });
    }

    getPrefabList(prefabNameList, callback) {
        let pathList = [];
        for (const name of prefabNameList) {
            if (this.prefabList[name] == null) {
                pathList.push(ConfigManager.GetPrefabPath(name));
            }
        }
        let target = this;
        let prefabRet = [];
        if (pathList.length == 0) {
            for (const iterator of prefabNameList) {
                prefabRet.push(target.prefabList[iterator]);
            }
            callback(null, prefabRet);
            return;
        }
        cc.loader.loadResArray(pathList, cc.Prefab, function (err, prefabArr) {
            for (const iterator of prefabArr) {
                target.prefabList[iterator.name] = iterator;
            }
            for (const iterator of prefabNameList) {
                prefabRet.push(target.prefabList[iterator]);
            }
            callback(err, prefabRet);
        });
    }

    clear() {
        this.prefabList = {};
    }
}
