/**
 * BaseScene 场景基类
 */
const { ccclass, property } = cc._decorator;
import { GameManager } from "../manager/GameManager";
import { GameGlobal } from "../model/GameGlobal";

import UIManager from "../uiFrame/UIManager";
@ccclass
export default abstract class BaseScene extends cc.Component {

    onLoad() {
        GameGlobal.scene = this;

        UIManager.getInstance().init(
            () => {
                GameManager.getInstance().init(this, this.onInit);
            },
        );
    }

    onInit(): void {
        cc.director.getScene().setScale(cc.v2(1, 1));
        this.showView();
    }

    abstract showView(): void;

}
