
const { ccclass, property } = cc._decorator;

@ccclass
export default class AsyncHelper extends cc.Component {

    static GetInstance(node: cc.Node = null): AsyncHelper {
        if (node == null) {
            if (AsyncHelper._instance == null) {
                AsyncHelper._instance = new AsyncHelper();
            }
            return AsyncHelper._instance;
        }
        let com = node.getComponent(AsyncHelper);
        if (com == null) {
            com = node.addComponent(AsyncHelper);
        }
        return com;
    }

    private static _instance: AsyncHelper;
    private timeoutIdList: NodeJS.Timeout[] = [];

    waitForSeconds(delay: number, callback: () => void, target = null, ...args: any[]): NodeJS.Timeout {
        let timeoutId = setTimeout(function () {
            SafeCall(target, callback, ...args);
        }, delay * 1000);
        this.timeoutIdList.push(timeoutId);
        return timeoutId;
    }

    stopAsync(timeoutId: NodeJS.Timeout): void {
        clearTimeout(timeoutId);
        let index = this.timeoutIdList.indexOf(timeoutId);
        this.timeoutIdList.slice(index, 1);
    }

    stopAllAsync(): void {
        for (const timeoutId of this.timeoutIdList) {
            clearTimeout(timeoutId);
        }
        this.timeoutIdList = [];
    }

    onDestroy(): void {
        this.stopAllAsync();
    }
}
