import CommonUtil from "../util/CommonUtil";

const { ccclass, property } = cc._decorator;

@ccclass
export default class SwipeButton extends cc.Component {
    @property(cc.Node)
    onState: cc.Node = null;
    @property(cc.Node)
    offState: cc.Node = null;
    @property(cc.Label)
    label: cc.Label = null;
    @property
    isOnStr: string = "";
    @property
    isOffStr: string = "";

    @property
    private _isOn: boolean = false;
    @property
    private _intractable: boolean = false;
    onLoad() {
        this.setBtnState();
        this.node.on(cc.Node.EventType.TOUCH_END, function (event) {
            this.invoke();
        }, this, true);
    }

    setBtnState() {
        this.onState.active = this._isOn;
        this.offState.active = !this._isOn;
        this.label.string = this._isOn ? this.isOnStr : this.isOffStr;
    }

    invoke(isOn = null) {
        if (isOn == null) {
            isOn = !this._isOn;
        }
        if (!this._intractable) {
            return;
        }
        this._isOn = isOn;
        this.setBtnState();
    }

    isOn() {
        return this._isOn;
    }

    setIntractable(intractable) {
        this._intractable = intractable;
    }

}
