
const { ccclass, property } = cc._decorator;

@ccclass
export default class ToggleControl extends cc.Component {
    @property(cc.Node)
    target: cc.Node[] = [];
    @property(cc.Color)
    onColor: cc.Color = null;
    @property(cc.Color)
    offColor: cc.Color = null;
    @property(cc.Node)
    onNode: cc.Node = null;
    @property(cc.Node)
    offNode: cc.Node = null;
    @property
    needSetColor: boolean = true;
    @property(cc.Label)
    labelList: cc.Label[] = [];

    @property
    _isOn = false;
    @property
    _tog = null;

    onLoad() {
        this._tog = this.node.getComponent(cc.Toggle);
        this.setIsOn();
    }

    update(dt) {
        if (this._isOn != this._tog.isChecked) {
            this.setIsOn();
        }
    }

    setIsOn() {
        this._isOn = this._tog.isChecked;
        if (this.onNode != null && this.offNode != null) {
            this.setIsOnNode();
        }
        if (this.needSetColor) {
            this.setColor();
        }
    }

    setIsOnNode() {
        this.onNode.active = this._isOn;
        this.offNode.active = !this._isOn;
    }

    setColor() {
        for (const iterator of this.target) {
            iterator.color = this._isOn ? this.onColor : this.offColor;
        }
    }

    setLabel(str) {
        for (const label of this.labelList) {
            label.string = str;
        }
    }
}
