/**
 * MainUI
 */

const { ccclass, property } = cc._decorator;

import MessageCenter, { MessageType } from "../../uiFrame/MessageCenter";
import UIBase from "../../uiFrame/UIBase";

@ccclass
export default class MainUI extends UIBase {
    static InGuide: boolean = false;

    static Create(): MainUI {
        if (MainUI._instance == null) {
            MainUI._instance = new MainUI();
            MainUI._instance.init();
        }
        return MainUI._instance;
    }

    private static _instance: MainUI = null;

    private content: cc.Node;

    init() {
        this.currentUIType.IsLobbyView = true;
        this.createCallBack = function () {
            this.initUI();
        };
        this.createAndAttachRoot("MainUI");
    }

    onRedisplay() {
        this.refresh();
    }

    initUI() {
        this.attach();
        this.refresh();
    }

    attach() {

    }

    refresh() {

    }

    onUpdate(dt) {

    }

    setBtn() {

    }

    onDestroyRoot() {
        MessageCenter.removeMsgListener(MessageType.MAIN);
    }

}
