export default class MessageCenter {
    static dicMessages = {};
    static addMsgListener(messageType: number, handler, target) {
        if (MessageCenter.dicMessages[messageType] == null) {
            const data = {
                handler,
                target,
            };
            MessageCenter.dicMessages[messageType] = data;
        }
    }

    static removeMsgListener(messageType: number) {
        if (MessageCenter.dicMessages[messageType] != null) {
            delete MessageCenter.dicMessages[messageType];
        }
    }

    static removeAllMsgListener(messageType: number) {
        MessageCenter.dicMessages = {};
    }

    static SendMessage(messageType: number, key: number, value = null) {
        if (MessageCenter.dicMessages[messageType] != null) {
            const data = MessageCenter.dicMessages[messageType];
            SafeCall(data.target, data.handler, { Key: key, Values: value });
        }
    }
}

export const MessageType = {
    MAIN: 1001,
    CLASSROOM: 1002,
    CAT_INFO: 1003,
    CAT: 1004,
    CAT_FEED: 1005,
    EXPLORE_AREA_INFO: 1006,
    EXPLORE_UI: 1007,
    RESEARCH_UI: 1008,
    SHOP_UI: 1009,
    CITY_UI: 1010,
};

export const Message = {
    USE_GOLD: 2001,
    ADD_CAT: 2002,
    LEARN_LESSON_FINISH: 2003,
    LEARN_TOTAL_FINISH: 2004,
    CAT_LEAVE: 2005,
    USE_ENERGY: 2006,
    ADD_ENERGY: 2007,
    EXP_UP: 2008,
    LEVEL_UP: 2009,
    USE_DIAMOND: 2010,
    CAT_FULLNESS_REDUCE: 2011,
    FIND_CAT_LIKE_FOOD: 2012,
    CAT_GET_GIFT: 2013,
    CAT_MOOD_CHANGE: 2014,
    CAT_HUNGER: 2015,
    CHANGE_NAME: 2016,
    CAT_FULLNESS_ADD: 2017,
    CAT_GRADUATE: 2018,
    CAT_STATE_CHANGE: 2019,
    CAT_EAT_CANDY: 2020,
    MAGIC_STAR_ADD: 2021,
    DRAG_SCREEN: 2022,
    GUIDE: 2023,
    PICK_GOLD: 2024,
    DESTROY: 2025,
    CAT_DIARY_CHANGE: 2026,
    POSITION: 2027,
    CLICK_BOTTOM_BUTTON: 2028,
    REFRESH_RED_DOT: 2029,
};
