const { ccclass, property } = cc._decorator;
import CommonUtil from "../../util/CommonUtil";
import { SysDefine, UIFormsLucencyType } from "./UITypeData";

@ccclass
export default class UIMaskMgr extends cc.Component {

    static getInstance() {
        if (this._Instance == null) {
            const node = new cc.Node("_UIMaskMgr");
            this._Instance = node.addComponent("UIMaskMgr");
            cc.game.addPersistRootNode(node);
        }
        return this._Instance;
    }

    private static _Instance = null;
    @property
    _popLayerMask: cc.Node = null;

    @property
    _uiCanvas = null;

    setUICanvas(uiCanvas) {
        this._uiCanvas = uiCanvas;
        this._popLayerMask = CommonUtil.findAChild(this._uiCanvas, "PopLayerMask");
    }

    setMaskWindow(goDisplayPlane: cc.Node, uiLucencyType) {
        if (uiLucencyType == UIFormsLucencyType.Lucency) {
            CommonUtil.SetActive(this._popLayerMask, null, true);
            this._popLayerMask.color = cc.color(
                SysDefine.SYS_UIMASK_LUCENCY_COLOR_RGB
                , SysDefine.SYS_UIMASK_LUCENCY_COLOR_RGB
                , SysDefine.SYS_UIMASK_LUCENCY_COLOR_RGB);
            this._popLayerMask.opacity = SysDefine.SYS_UIMASK_LUCENCY_COLOR_A;
        }
        if (uiLucencyType == UIFormsLucencyType.Impenetrable) {
            CommonUtil.SetActive(this._popLayerMask, null, true);
            this._popLayerMask.color = cc.color(
                SysDefine.SYS_UIMASK_IMPENETRABLE_COLOR_RGB
                , SysDefine.SYS_UIMASK_IMPENETRABLE_COLOR_RGB
                , SysDefine.SYS_UIMASK_IMPENETRABLE_COLOR_RGB);
            this._popLayerMask.opacity = SysDefine.SYS_UIMASK_IMPENETRABLE_COLOR_A;
        }
        if (uiLucencyType == UIFormsLucencyType.Penetrate) {
            CommonUtil.SetActive(this._popLayerMask, null, false);
        }
        this._popLayerMask.setSiblingIndex(this._popLayerMask.parent.childrenCount);
        goDisplayPlane.setSiblingIndex(this._popLayerMask.parent.childrenCount);
    }

    cancelMaskWindow() {
        CommonUtil.SetActive(this._popLayerMask, null, false);
    }
}
