/**
 *
 */
export class ByteUtil {

    static bufToInt32(num1: number, num2: number, num3: number, num4: number): number {
        let num = 0;
        num = num + num1;
        num = num + this.leftShift(num2, 8);
        num = num + this.leftShift(num3, 16);
        num = num + this.leftShift(num4, 24);

        return num;
    }

    static int32ToBufNumTable(num: number): number[] {
        const numTable = new Array();
        numTable[0] = num % 256;
        numTable[1] = this.rightShift(num, 8) % 256;
        numTable[2] = this.rightShift(num, 16) % 256;
        numTable[3] = this.rightShift(num, 24) % 256;

        return numTable;
    }

    // int转二进制
    static int32ToBufStr(num: number): string {
        let str = "";
        str = str + this.numToAscii(this.rightShift(num, 24));
        str = str + this.numToAscii(this.rightShift(num, 16));
        str = str + this.numToAscii(this.rightShift(num, 8));
        str = str + this.numToAscii(num);
        return str;
    }

    // 二进制转shot
    static bufToInt16(num1: number, num2: number): number {
        let num = 0;
        num = num + this.leftShift(num1, 8);
        num = num + num2;
        return num;
    }

    // shot转二进制
    static int16ToBufStr(num: number): string {
        let str = "";
        str = str + this.numToAscii(this.rightShift(num, 8));
        str = str + this.numToAscii(num);
        return str;
    }

    static leftShift(num: number, shift: number): number {
        return Math.floor(num * Math.pow(2, shift));
    }

    static rightShift(num: number, shift: number): number {
        return Math.floor(num / Math.pow(2, shift));
    }

    static numToAscii(num: number): string {
        num = num % 256;
        return String.fromCharCode(num);
    }

    static numberToBitsArr(num: number): number[] {
        const result = new Array();
        const bitLen = 64;
        for (let index = 0; index < bitLen; index++) {
            result[bitLen - index - 1] = num % 2;
            num = Math.floor(num / 2);
        }
        return result;
    }

    static band(num1: number, num2: number): number {
        const bitNumArr1 = ByteUtil.numberToBitsArr(num1);
        const bitNumArr2 = ByteUtil.numberToBitsArr(num2);
        const result = new Array();
        for (let index = 0; index < bitNumArr1.length; index++) {
            const element = bitNumArr1[index];
            let bit = 0;
            if (element == 1 && bitNumArr2[index] == 1) {
                bit = 1;
            }
            result[index] = bit;
        }
        let num = 0;

        for (let index = 0; index < result.length; index++) {
            const element = result[index];
            num = num + element * Math.pow(2, result.length - index);
        }
        return num;
    }

}
