import CommonUtil from "./CommonUtil";

const { ccclass, property } = cc._decorator;
@ccclass
export default class CloneUI extends cc.Component {
    static Create(parent: cc.Node, path: string, newParent: cc.Node) {
        let node = CommonUtil.findAChild(parent, path);
        if (node == null) {
            return null;
        }

        let clone = cc.instantiate(node);
        clone.removeComponent(cc.Widget);
        clone.parent = newParent;
        let cloneUI = clone.addComponent(CloneUI);
        cloneUI.origin = node;
        cloneUI.originLastPos = node.getPosition();
        let wordPos = node.convertToWorldSpace(cloneUI.originLastPos);
        let localPos = clone.convertToNodeSpace(wordPos);
        cloneUI.node.setPosition(cc.v2(localPos.x, localPos.y));

        return cloneUI;
    }
    private followMove: boolean = true;

    private origin: cc.Node = null;
    private originLastPos = null;

    SetFollowMove(param: boolean) {
        this.followMove = param;
    }
    update(dt) {
        if (this.origin != null && this.followMove) {
            let originNodePos = this.origin.getPosition();
            if (this.originLastPos != originNodePos) {
                let wordPos = this.origin.convertToWorldSpace(this.originLastPos);
                let localPos = this.node.convertToNodeSpace(wordPos);
                this.node.setPosition(cc.v2(localPos.x, localPos.y));
            }
        }
    }

    Destroy() {
        this.node.destroy();
    }
}
