export class LocalSave {
    static SAVE_KEY_SESSION = "session";
    static SAVE_KEY_NOVICE = "novice";
    static SAVE_KEY_ARENA_BATTLE = "arenaBattle";
    static SAVE_KEY_SIGN_IN = "signIn";

    static saveData(key: string, data): void {
        cc.sys.localStorage.setItem(key, data);
    }

    static getData(key: string, defaultValue: any = ""): any {
        const json = cc.sys.localStorage.getItem(key);
        if (json != null && json != "null" && json.length > 0) {
            return json;
        }
        return defaultValue;
    }

    static hasKey(key: string): boolean {
        const data = cc.sys.localStorage.getItem(key);
        return data != null && data != "null" && data.length > 0;
    }

    static deleteKey(key: string): any {
        return cc.sys.localStorage.removeItem(key);
    }

}
