
declare namespace cc {

    export let geomUtils = {
        intersect: any = {
            raycast: any
        }
    }

    export class MeshRenderer extends RenderComponent {
        [x: string]: boolean;
    };

    export class Material extends Asset {
        copy(mat: Material): void;

        setProperty(name: string, val: any, force?: boolean): void;
        define(name: string, val: boolean, force?: boolean): void;

        static getBuiltinMaterial(name: string): Material;

        static getInstantiatedBuiltinMaterial(name: string, renderComponent): Material;
        static getInstantiatedMaterial(mat: string, renderComponent): Material;

    };

    export class GameExt extends Game {
        _renderContext: any;
    }

    export class TweenExt extends cc.Tween {
        target(target: any): TweenExt;
        to(duration: number, props: any, opts: { progress?: Function; easing: Function | string; }): Tween;
        by(duration: number, props: any, opts: { progress?: Function; easing: Function | string; }): Tween;
    }
    export var game: GameExt;

    export function tween(target?: any): cc.TweenExt;
}
