/* global Editor */

var fs = require("fs");
var path = require("path");

var self = {
    onBeforeBuildFinish: function (options, callback) {
        Editor.log('Building ' + options.platform + ' to ' + options.dest);

        self.handleGameGlobalJson(options, callback);
    },

    handleGameGlobalJson: function (options, callback) {
        'use strict';

        if (options.platform != 'wechatgame') {
            return;
        }
        try {
            var gameJsonPath = path.join(options.dest, 'game.json');
            Editor.log("Process: " + gameJsonPath);
            var gameJsonStr = fs.readFileSync(gameJsonPath, 'utf8');
            // Editor.log("[DEBUG] Process: " + gameJsonStr);
            var gameJson = JSON.parse(gameJsonStr);
            var navigateList = gameJson.navigateToMiniProgramAppIdList;
            if (navigateList === undefined) {
                navigateList = gameJson.navigateToMiniProgramAppIdList = [];
            }

            navigateList.push("wx81a41ea914f34b85"); // 龙德广场小程序
            fs.writeFileSync(gameJsonPath, JSON.stringify(gameJson, null, 2));
        } catch (e) {
            Editor.log("Process GameGlobalJson Failed: " + e);
        }


        callback();
    }
};

module.exports = self;