/* global Editor */
const path = require("fire-path");
const fs = require("fire-fs");
module.exports = {
    load() {
        // execute when package loaded
    },

    unload() {
        // execute when package unloaded
    },

    // register your ipc messages here
    messages: {
        'open'() {
            // open entry panel registered in package.json
            Editor.Panel.open('PluginsDebug');
        },
        'reloadPlugin'() {
            // send ipc message to panel
            Editor.Package.load(path.join(Editor.Project.path, "packages", "build_index"));
            let packagesDir = path.join(Editor.Project.path, "packages");
            let fPaths = fs.readdirSync(packagesDir);
            for (const f of fPaths) {
                let fullPath = path.join(packagesDir, f);
                Editor.Package.load(fullPath);
            }
        }
    },
};